# Product Info API

1. product-info-api will read products csv file via spark structured streaming (readStream) and write (writeStream) all records to kafka topic with specific batchId. This event will be triggered via POST method by uploading csv file.
2. This API will consume the kafka topic via spark structured streaming (readStream) and write (writeStream)  transformed records to another csv. This event will be triggered via GET call by passing batchId 
3. Additionally GET method will return processed data with CollectionAccumulator concept in spark.
4. Postman script and input csv files are available in src/main/resources/postman folder.

Technologies Used :

1. Spring boot
2. Java8
3. Spark Core
4. Spark Sql
5. Spark kafka Connector
5. Spring Webflux